// cs154v1.cpp : Defines the entry point for the console application.
/*
How did I get this working?
++Names++: this was in a folder named OpenCVTest1 on the desktop
0. (NO) named an image im1.jpg on the desktop... check user name in the path name below...
1. (YES) install OpenCV for Windows
2. (NO) go to http://opencvlibrary.sourceforge.net/VisualC%2B%2B - then carefully do these things:
3. (NO) copied this c++ code from the nice resource http://www.cs.iit.edu/~agam/cs512/lect-notes/opencv-intro/opencv-intro.html
4. (NO) it complained about symbols being missing, so I added the line
   cxcore.lib cv.lib highgui.lib cvaux.lib cvcam.lib
   in the Project... ...properties ; Linker ... input tab ; additional dependencies line
   for BOTH debug and release versions
5. (NO) it complained about DLLs being missing, then
   copied all of the dlls from c:\Program Files\OpenCV\bin to the folder
   where this executable is being created (actually twice -- once for the
   debug version and once for the release version
6. (HOPEFULLY) then, it worked!
7. the program quit when you quit the image window
*. (GET FROM TIM) No Microsoft Visual Studio .NET? 
 - you may want to check out
 http://www.dh.aist.go.jp/~kimura/opencv/opencv-1.0.html.en, aptly named
 "I built OpenCV 1.0 on the Cygwin environment"
 or 
 Pyry Matikainen's Java frame-grabbing (and analysis code)
 */
//

#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <fstream>
#include <string>
#include <tchar.h>
#include <math.h>
#include <cv.h>
#include <cxcore.h>
#include <highgui.h>

#include "squares.h"

using namespace std; // ouch!

/* Global variables */

int countMain = 0;
int imgNumMain = 0;

char wndname[] = "Camera 1";
char wndname2[] = "Camera 2";
char wndname3[] = "Painted image 1";
char wndname4[] = "Painted image 2";

void setGlobals();  // the code appears at the very bottom of this file

CvMat* sharpenFilter;

void RGBtoHSV( double r, double g, double b, double *h, double *s, double *v );

// here, static refers to the fact that these variables
// are local to this file (they're not available in other files,
// which is safer because it allows reuse of their names)
static CvSize imageSize;
static CvPoint old_click_pt;
static CvPoint new_click_pt;
static double framenum;

// global points for drawing boxes, defining loops, etc.
static CvPoint pt1; 
static CvPoint pt2; 
static CvPoint pt3;
static CvPoint pt4;
static CvPoint pt5;
static CvPoint pt6;
static CvPoint pt7;

// global calibration data
static float* M; 
static float* D;

// more global variables
// these are simply recording all the different states you
// can put the program in via the keyboard
static bool capturing = true;
static bool capturing2 = true;
static bool quittingTime = false;

static int frameNumber = 0;
static int keyCode = -1;

// pointers to images in memory
static IplImage *frame;
static IplImage *undis_frame;
static IplImage *undis_frame_painted;
static IplImage *frame2;
static IplImage *undis_frame2;
static IplImage *undis_frame_painted2;

static CvArr* undisMap;

IplImage* findRectangles(IplImage* oldImg, const char* filename)
{
	CvMemStorage* storage = cvCreateMemStorage(0);
	IplImage* img = cvCloneImage(oldImg);
	
	cvFilter2D(img, img, sharpenFilter);
	
	IplImage* rectImg = drawSquares( img, findSquares4( img, storage ), filename );
	
	cvReleaseImage(&img);
	
	cvReleaseMemStorage( &storage);
	
	return rectImg;
}

// handle mouse clicks here
void mouse_callback(int event, int x, int y, int flags, void* param)
{
	if (event == CV_EVENT_LBUTTONDOWN)
	{
		// cout << "(x,y) = (" << x << "," << y << ")" << endl;

		// reset old_click_pt
		old_click_pt.x = new_click_pt.x;
		old_click_pt.y = new_click_pt.y;

		// get new click point -- note the coordinate change in y
		new_click_pt.x = x;  // coming in from the window system
		new_click_pt.y = imageSize.height-y;  // window system and images have different y axes
	}
}

//CvMouseCallback theMouseCallback = &mouse_callback;

// print pixel information
void pixelInformation(IplImage* f)
{
	if (f == NULL) return;

	// see if things have changed...
	if (new_click_pt.x != old_click_pt.x || new_click_pt.y != old_click_pt.y) // has it changed?
	{
		if (new_click_pt.x < 0 || new_click_pt.x > 319 || new_click_pt.y < 0 || new_click_pt.y > 239) return;
		// draw a line from old to new
		// cvLine(frame,old_click_pt,new_click_pt,CV_RGB(255,0,0),/*thickness*/1,/*connectivity*/8);
		// set the old = the new
		old_click_pt.x = new_click_pt.x;
		old_click_pt.y = new_click_pt.y;
		// print the RGB values and coordinates of the newly clicked point:
		// note that blue is #0, green is #1, and red is #2 !!

		/* note that this uses the undistorted frame right here... */

		// this is insane!!!
		// see the processRed function for an explanation
		// of why we need "realy" for images from file
		int realy = new_click_pt.y;
		uchar* pixel = cvPtr2D(f,realy,new_click_pt.x);

		cout << "(x,y) = (" << new_click_pt.x << "," << new_click_pt.y << ") with (r,g,b) = ("
			 << (int)(pixel[2]) << "," << (int)(pixel[1]) << "," << (int)(pixel[0]) << ")" << endl;

		double hue,sat,val;
		RGBtoHSV((double)pixel[2],(double)pixel[1],(double)pixel[0],&hue,&sat,&val);

		cout << "           and (h,s,v) = (" << hue << "," << sat << "," << val << ")" << endl;
	}
}

CvScalar whiteness(const CvScalar& val)
{
	double h, s, v;
	RGBtoHSV(val.val[2], val.val[1], val.val[0], &h, &s, &v);
	
	CvScalar result;
	result.val[0] = v*v*v*v*v*v*(1.0-s)*(1.0-s)*(1.0-s)*(1.0-s)*(1.0-s)*255;
	result.val[1] = 0;
	result.val[2] = 0;
	result.val[3] = 0;
	return result;
}

/* End of globals */

//int _tmain(int argc, _TCHAR* argv[])
//{
////////////////////////////////////////////////////////////////////////
//
// hello-world.cpp
//
// This is a simple, introductory OpenCV program. The program reads an
// image from a file, inverts it, and displays the result. 
//
////////////////////////////////////////////////////////////////////////

void myexit(int y = 0)
{
  int x;
  printf("enter a number to exit\n");
  scanf("%d", &x);
  exit(0);
}

int main(int argc, char *argv[])
{
	/*
	IplImage* img = 0; 
	int height,width,step,channels;
	uchar *data;
	int i,j,k;

	// get the image data
	height    = img->height;
	width     = img->width;
	step      = img->widthStep;
	channels  = img->nChannels;
	data      = (uchar *)img->imageData;
	printf("Processing a %dx%d image with %d channels\n",height,width,channels); 

	// create a window
	cvNamedWindow("mainWin", CV_WINDOW_AUTOSIZE); 
	cvMoveWindow("mainWin", 100, 100);

	// invert the image
	for(i=0;i<height;i++) for(j=0;j<width;j++) for(k=0;k<channels;k++)
		data[i*step+j*channels+k]=255-data[i*step+j*channels+k];

	// show the image
	cvShowImage("mainWin", img );

	// wait for a key - press a key with focus on the image to quit
	cvWaitKey(0);

	// release the image
	cvReleaseImage(&img );
	*/
	/* end of the static-image part */

	/* start of our frame-grabbing program */

	setGlobals();

	cvNamedWindow( wndname, CV_WINDOW_AUTOSIZE );
	cvNamedWindow( wndname2, CV_WINDOW_AUTOSIZE );
	cvNamedWindow( wndname3, CV_WINDOW_AUTOSIZE );
	cvNamedWindow( wndname4, CV_WINDOW_AUTOSIZE );

	sharpenFilter = cvCreateMat(3, 3, CV_32FC1);

	for (int i = 0; i < 3; i++)
	{
		for (int j = 0; j < 3; j++)
			cvSetReal2D(sharpenFilter, i, j, -.125);
	}
	cvSetReal2D(sharpenFilter, 1, 1, 2.0);

    /*
	 * set up the mouse input
	 */
	//cvSetMouseCallback( wndname, mouse_callback );
	cvSetMouseCallback( wndname2, mouse_callback /*theMouseCallback*/ );

	/*
	 * more camera-specific stuff
	 */
	CvCapture* capture = 0;
	CvCapture* capture2 = 0;
	
	int i = 1;
	
	capture = cvCaptureFromCAM(0);
	capture2 = cvCaptureFromCAM(-1);
	
	// this is allocating the undis_frame once (it will get written each time)
	// get one frame and then copy it...
	if (cvGrabFrame(capture)) 
	{
		frame = cvRetrieveFrame( capture );
		undis_frame = cvCloneImage(frame);
		undis_frame_painted = cvCloneImage(frame);
		// now let's set up the undistortion parameters
		// note that the docs say 3*wider, but that did not work
		// 3*wider _and_ 3*higher worked...
		undisMap = cvCreateMat( imageSize.width*3, imageSize.height*3, CV_32SC3 );
		// need to release this at the end of the program...
		cvUnDistortInit( frame, undisMap, M, D, 1 );
	}
	else
	{
		cout << "No camera??" << endl;
		capturing = false;
	}

	if (cvGrabFrame(capture2))
	{
		frame2 = cvRetrieveFrame( capture2 );
		undis_frame2 = cvCloneImage(frame2);
		undis_frame_painted2 = cvCloneImage(frame2);
		// now let's set up the undistortion parameters
		// note that the docs say 3*wider, but that did not work
		// 3*wider _and_ 3*higher worked...
		undisMap = cvCreateMat( imageSize.width*3, imageSize.height*3, CV_32SC3 );
		// need to release this at the end of the program...
		cvUnDistortInit( frame2, undisMap, M, D, 1 );
	}
	else
	{
		cout << "No camera??" << endl;
		capturing2 = false;
	}

	// main loop
	while (!quittingTime)
    {
		/*
		 * live video capture
		 */
		if (capturing)
		{
			if( !cvGrabFrame( capture ))   break;
			frame = cvRetrieveFrame( capture );
			if( !frame ) break;

			// cvUnDistortOnce( frame, undis_frame, M, D, 1 );  // might take some extra time...
			cvUnDistort( frame, undis_frame, undisMap, 1 );
			
			cvReleaseImage(&undis_frame_painted);
			
			undis_frame_painted = cvCloneImage(undis_frame);
			
			for(int i = 0; i < undis_frame_painted->width; ++i)
				for(int j = 0; j < undis_frame_painted->height; ++j)
					cvSet2D(undis_frame_painted, j, i, whiteness(cvGet2D(undis_frame_painted, j, i)));
			
			IplImage *rectangles = findRectangles(undis_frame_painted, "./input.txt");
			if (PRINT_CAM_RAW)
			{
					char tempBuffer[50];
					itoa(imgNumMain, tempBuffer, 10);
					string tempBuffer2 = tempBuffer;

					string debugName = "c:\\images\\input.raw.";
					debugName += tempBuffer2;
					debugName += ".jpg";

					countMain = 0;

					imgNumMain++;

					cvSaveImage(debugName.c_str(), (CvArr*)frame);
			}

			cvReleaseImage(&undis_frame_painted);
			undis_frame_painted = cvCloneImage(rectangles);
			cvReleaseImage(&rectangles);
		}

		if (capturing2)
		{
			if( !cvGrabFrame( capture2 ))   break;
			frame2 = cvRetrieveFrame( capture2 );
			if( !frame2 ) break;
			
			// cvUnDistortOnce( frame, undis_frame, M, D, 1 );  // might take some extra time...
			cvUnDistort( frame2, undis_frame2, undisMap, 1 );
			
			cvReleaseImage(&undis_frame_painted2);
			
			undis_frame_painted2 = cvCloneImage(undis_frame2);
			
			for(int i = 0; i < undis_frame_painted2->width; ++i)
				for(int j = 0; j < undis_frame_painted2->height; ++j)
					cvSet2D(undis_frame_painted2, j, i, whiteness(cvGet2D(undis_frame_painted2, j, i)));
			
			IplImage *rectangles = findRectangles(undis_frame_painted2, "./input2.txt");

			if (PRINT_CAM_RAW)
			{
					char tempBuffer[50];
					itoa(imgNumMain, tempBuffer, 10);
					string tempBuffer2 = tempBuffer;

					string debugName = "c:\\images\\input2.raw.";
					debugName += tempBuffer2;
					debugName += ".jpg";

					countMain = 0;

					imgNumMain++;

					cvSaveImage(debugName.c_str(), (CvArr*)frame2);
			}


			cvReleaseImage(&undis_frame_painted2);
			undis_frame_painted2 = cvCloneImage(rectangles);
			cvReleaseImage(&rectangles);
		}
		
		/*
		 * this call will check for any mouse clicks, non-blocking
		 *
		 * ** click only on the undis_image (undistorted image) **
		 */
		pixelInformation(undis_frame_painted);

		/*
		 * display everything in the windows
		 */
		cvShowImage(wndname, frame);  // camera image
		cvShowImage(wndname3, undis_frame_painted);  // undis. image with user's graphics

		cvShowImage(wndname2, frame2);  // camera image
		cvShowImage(wndname4, undis_frame_painted2);  // undis. image with user's graphics

		/*
		 * conditionals to handle keypresses
		 *
		 * gets keypress and checks for 'q' to quit
		 */
		if( (keyCode = cvWaitKey( 10 )) == ((int)'q') ) {          
			break;                       // quit everything
		}
	}

	// release things before quitting
    cvReleaseCapture( &capture );
	cvDestroyWindow("result");

    return 0;
}


// just in case you'd like to use these...
inline double mymin(double a, double b) { return a<b?a:b; }
inline double mymax(double a, double b) { return a>b?a:b; }

// read about HSV at http://en.wikipedia.org/wiki/HSV_color_space
// and http://www.cs.rit.edu/~ncs/color/t_convert.html#RGB%20to%20HSV%20&%20HSV%20to%20RGB
//
// feel free to grab code from above or elsewhere online, if you'd like to 
// be sure you understand what RANGE _your_ code for HSV is "returning"
// in the h, s, and v pointers...
void RGBtoHSV( double r, double g, double b, double *h, double *s, double *v )
{
	double maxRGB;
	double minRGB;
	double delta;

	// get max and min
	if(r >= g && r >= b)
	{
		maxRGB = r;
		if(g >= b)
			minRGB = b;
		else
			minRGB = g;
	}
	else if(g >= b)
	{
		maxRGB = g;
		if(r >= b)
			minRGB = b;
		else
			minRGB = r;
	}
	else
	{
		maxRGB = b;
		if(r >= g)
			minRGB = g;
		else
			minRGB = r;
	}

	delta = maxRGB - minRGB;
	*v = maxRGB/255.0;

	if (maxRGB <= 0.0)
	{
		*h = -1;
		*s = 0;
		return;
	}

	*s = delta/maxRGB;   // better scaling than 255!
	if(delta == 0)
	{
		*h = -1;
		return;
	}

	if(r == maxRGB)
		*h = (g - b)/delta;
	else if (g == maxRGB)
		*h = (1.0/3.0) + (b-r)/delta;
	else
		*h = (2.0/3.0) + (r-g)/delta;
}

void setGlobals()
{
	// mouse click locations (old and new, to tell if we've
	// clicked on a new point
	old_click_pt.x = 0;
	old_click_pt.y = 0;
	new_click_pt.x = 0;
	new_click_pt.y = 0;

	// in theory these should get deleted at the end of the program, too...

	// this is the calibration matrix of the camera
	M = new float[9];
	M[0]=    393.1788940f; M[1]=      0.0000000f; M[2]=    162.8373871f;
	M[3]=      0.0000000f; M[4]=    395.7017517f; M[5]=    121.8078156f;
	M[6]=      0.0000000f; M[7]=      0.0000000f; M[8]=      1.0000000f;

	// these are the distortion parameters of the camera
    D = new float[4];
	D[0]=-0.358375f;
	D[1]=0.168058f;
	D[2]=-0.006497f;
	D[3]=0.001283f;

    // theseimage sizes are hard-coded, but should probably be obtained for each
    // image individually -- however, with our cameras and images, this is safe.
	imageSize.width = 320; imageSize.height = 240;

	// set up some global points for drawing, etc.
    int margin = 12;
	pt1.x = margin; pt1.y = margin; 
    pt2.x = imageSize.width-margin; pt2.y = imageSize.height-margin; 

	pt3.x = imageSize.width/2;
	pt3.y = imageSize.height/2;

	pt4.x = 80;   // p4 and p5 are the rectangle in which we
	pt4.y = 12;   // search for pixels of the correct h, s, v...

	pt5.x = 240;
	pt5.y = 228;

	pt6.x = 92; 
	pt6.y = 24;

	pt7.x = 228;
	pt7.y = 216;

}


